% realimentacion de estado del ascensor
clear all;
close all;
clc;
%matrices del sistema
A=[-196 -238 0 0; 1157.4 -236.11 -1.361e5 0; 0 0.006 0 -1 ; 0 0 98 0];
B=[1000; 0; 0; 0];
C=[0 0 0 1] ;
C2=eye(4);
D2=[0; 0; 0; 0];
Ts=0.002;
P1=ss(A,B,C,0);
clc;
disp(' Modelo de Estado');
disp(' ')
P1

%disp(' calculo de la matriz transferencia (Simblico)')
%syms s;
%Id=eye(4);
%Fi=(s*Id-A);
%disp(' calculo de la matriz de transicion [sI-A](Simblico)')
%Fi
%disp(' Determinante (Simblico)')
%vpa(det(Fi),5)
%pause
%disp(' Inversa')
%Fi2=Fi^-1
%disp(' Transferencia')

%G1=vpa(C*inv(Fi)*B,3)

disp(' ')
disp(' ')
disp(' autovalores del modelo')
disp(' ')
pole(P1)
disp(' ')

%%
P1.c=C2;
P1.d=D2;
[Y,T]=step(P1);
figure(1);
plot(T,Y(:,1),'r')
title('CORIENTE DEL MOTOR');
ylabel('Amp.');
grid on;
figure(2);
plot(T,Y(:,2),'r')
title('VELOCIDAD DEL MOTOR');
ylabel('rad/seg');
grid on;
figure(3)
plot(T,Y(:,3),'r')
title('');
title('ESTIRAMIENTO DE CABLE ');
ylabel('M');
grid on;
figure(4);
plot(T,Y(:,4),'r')
title('VELOCIDAD DE LA CABINA');
ylabel('M/S');
grid on;

%%
% MODELO DE ESTADOS DISCRETO

close all;
P2=c2d(P1,Ts);
clc;
disp(' Modelo de Estado Discreto');
P2
[Yd,Td]=step(P2,20);
figure(5)
step(P2,20);
%figure(1);
%plot(Td,Yd(:,1),'r')
%title('CORIENTE DEL MOTOR');
%ylabel('Amp.');
%grid on;
%figure(2);
%plot(Td,Yd(:,2),'r')
%title('VELOCIDAD DEL MOTOR');
%ylabel('rad/seg');
%grid on;
%figure(3)
%plot(Td,Yd(:,3),'r')
%title('VELOCIDAD DE LA CABINA');
%ylabel('M/S');
%grid on;
%figure(4);
%plot(Td,Yd(:,4),'r')
%title('ESTIRAMIENTO DE CABLE');
%ylabel('M');
%grid on;
%%
clc;
disp('  autovalores deseados para el sistema');
disp('  sobrepico= 0 Ts[2%] = 2 seg.');
disp(' ');

polos=[-1.5 -1.5 -15 -22.5]
polosd=exp(Ts*polos)
Kt1=acker(P2.a,P2.b,polosd);

disp('   vector de realimentacion')

Kt1

A=P2.a-P2.b*Kt1;
P3=P2;
P3.a=A;

%%
clc;
disp('  Modelo realimentado');

P3

disp('  Autovalores realimentados.')

pole(P3)


%%
clc;
close all;
figure(5)
step(P3,20);
[Yr,Tr]=step(P3,20);
figure(1);
plot(Tr,Yr(:,1),'b')
title('X1:CORIENTE DEL MOTOR');
ylabel('Amp.');
grid on;
figure(2);
plot(Tr,Yr(:,2),'b')
title('X2:VELOCIDAD DEL MOTOR');
ylabel('rad/seg');
grid on;
figure(4);
plot(Tr,Yr(:,3),'b')
title('X3:ESTIRAMIENTO DE CABLE');
ylabel('M');
grid on;
figure(3)
plot(Tr,Yr(:,4),'b')
title('X4:VELOCIDAD DE LA CABINA');
ylabel('M/S');
grid on;
figure(5)
step(P3,20);

%%
clc;
P4=ss(P3.a,P3.b,[0 1 0 0],[0],Ts)
Kx=dcgain(P4)

disp(' Vector de Realimentacion Recalculado')

Ao=31.4/Kx

Kt2=Kt1/Ao

%%
clc;
A=P2.a-P2.b*Kt1;
P4=P2;
P4.a=A;
P4.b=P2.b*Ao;

disp('  Nuevo Modelo Realimentado')

P4


disp('  Autovalores realimentados.')

pole(P4)

%%
close all

[Yr,Tr]=step(P4,20);
figure(1);
plot(Tr,Yr(:,1),'b')
title('X1:CORIENTE DEL MOTOR');
ylabel('Amp.');
grid on;
hold on
plot(Td,Yd(:,1),'r')
hold off
figure(2);
plot(Tr,Yr(:,2),'b')
title('X2:VELOCIDAD DEL MOTOR');
ylabel('rad/seg');
grid on;
hold on
plot(Td,Yd(:,2),'r')
hold off
figure(3)
plot(Tr,Yr(:,4),'b')
title('X4:VELOCIDAD DE LA CABINA');
ylabel('M/S');
grid on;
hold on
plot(Td,Yd(:,4),'r')
hold off
figure(4);
plot(Tr,Yr(:,3),'b')
title('X3:ESTIRAMIENTO DE CABLE');
ylabel('M');
grid on;
hold on
plot(Td,Yd(:,3),'r')
hold off

%%
% Datos Para el ejercicio del Ascensor (SIMULINK)

Ra=1.96;
La=0.01;
Kt=2.5;
Kw=2.38;    
Ai=10;

J=5.4;
B=1275;
K=49000;
M=500;
Bm= .000000001;

N2=50;
N1=1;

r1=0.3;

Ai=Kt1(1)/Kt2(1)*Ai;
K1=Kt2(1);
K2=Kt2(2);
K3=Kt2(3);
K4=Kt2(4);
asc_realim;
%K1=0;
%K2=0;
%K3=0;
%K4=0;

close all
